-- C36301B.ADA

--                             Grant of Unlimited Rights
--
--     Under contracts F33600-87-D-0337, F33600-84-D-0280, MDA903-79-C-0687,
--     F08630-91-C-0015, and DCA100-97-D-0025, the U.S. Government obtained
--     unlimited rights in the software and documentation contained herein.
--     Unlimited rights are defined in DFAR 252.227-7013(a)(19).  By making
--     this public release, the Government intends to confer upon all
--     recipients unlimited rights  equal to those held by the Government.
--     These rights include rights to use, duplicate, release or disclose the
--     released technical data and computer software in whole or in part, in
--     any manner and for any purpose whatsoever, and to have or permit others
--     to do so.
--
--                                    DISCLAIMER
--
--     ALL MATERIALS OR INFORMATION HEREIN RELEASED, MADE AVAILABLE OR
--     DISCLOSED ARE AS IS.  THE GOVERNMENT MAKES NO EXPRESS OR IMPLIED
--     WARRANTY AS TO ANY MATTER WHATSOEVER, INCLUDING THE CONDITIONS OF THE
--     SOFTWARE, DOCUMENTATION OR OTHER INFORMATION RELEASED, MADE AVAILABLE
--     OR DISCLOSED, OR THE OWNERSHIP, MERCHANTABILITY, OR FITNESS FOR A
--     PARTICULAR PURPOSE OF SAID MATERIAL.
--*
-- CHECK THAT PREDEFINED STRING ATTRIBUTES ARE CORRECTLY IMPLEMENTED.

-- CASE B: STRING OF LENGTH INTEGER'LAST

-- DAT 2/17/81
-- JBG 12/28/82

with Report;
procedure C36301b is

   use Report;

   subtype Str2 is String (1 .. Integer'Last);

begin
   Test ("C36301B", "CHECK ATTRIBUTES OF LONGEST STRING");

   if Str2'First /= 1 then
      Failed ("STR'FIRST NOT 1");
   end if;

   if Str2'Last /= Integer'Last then
      Failed ("STR'LAST NOT INTEGER'LAST");
   end if;

   if Str2'Length /= Integer'Last then
      Failed ("'LENGTH NOT INTEGER'LAST");
   end if;

   Result;
end C36301b;
