
WITH REPORT; USE REPORT;
WITH C83030C_DECL1, C83030C_DECL2; USE C83030C_DECL1, C83030C_DECL2;
PROCEDURE C83030C IS
BEGIN
     TEST ("C83030C", "CHECK THAT WITHIN A GENERIC SUBPROGRAM BODY " &
                      "COMPILED AS A SUBUNIT IN THE SAME COMPILATION," &
                      " NON-HOMOGRAPH SUBPROGRAMS DECLARED OUTSIDE " &
                      "THE GENERIC UNIT, AND HAVING THE SAME " &
                      "IDENTIFIER, ARE NOT HIDDEN");

     ONE:
     DECLARE
          PROCEDURE PROC1 IS NEW C83030C_DECL2.C83030C_PROC1;
     BEGIN
          IF GLOBAL /= IDENT_INT(INTEGER'FIRST) THEN
               FAILED ("INCORRECT VALUE FOR START OF TEST ONE");
          END IF;
          PROC1;
          IF GLOBAL /= IDENT_INT(3) THEN
               FAILED ("INCORRECT VALUE FOR END OF TEST ONE");
          END IF;

          GLOBAL := IDENT_INT(INTEGER'FIRST);
          SWITCH := TRUE;
     END ONE;

     TWO:
     DECLARE
          PROCEDURE PROC2 IS NEW C83030C_DECL2.C83030C_PROC2(INTEGER);
     BEGIN
          IF GLOBAL /= IDENT_INT(INTEGER'FIRST) THEN
               FAILED ("INCORRECT VALUE FOR START OF TEST TWO");
          END IF;
          PROC2 (1);
          IF GLOBAL /= IDENT_INT(3) THEN
               FAILED ("INCORRECT VALUE FOR END OF TEST TWO");
          END IF;

          SWITCH := TRUE;
     END TWO;

     THREE:
     DECLARE
          FUNCTION FUNC3 IS NEW C83030C_DECL2.C83030C_FUNC3;
     BEGIN
          IF FUNC3 /= IDENT_INT(3) THEN
               FAILED ("INCORRECT VALUE FOR END OF TEST THREE");
          END IF;

          SWITCH := TRUE;
     END THREE;

     FOUR:
     DECLARE
          FUNCTION FUNC4 IS NEW C83030C_DECL2.C83030C_FUNC4 (INTEGER);
     BEGIN
          IF FUNC4 /= IDENT_INT(INTEGER'FIRST) THEN
               FAILED ("INCORRECT VALUE FOR END OF TEST FOUR");
          END IF;

          GLOBAL := INTEGER'FIRST;
          SWITCH := TRUE;
     END FOUR;

     RESULT;
END C83030C;
