
WITH SYSTEM; USE SYSTEM;
WITH REPORT; USE REPORT;
WITH C94004B_TASK; WITH C94004B_PKG;
PROCEDURE C94004B IS

     T : C94004B_TASK.ACC_TASK;

BEGIN
     TEST ("C94004B", "CHECK THAT A MAIN PROGRAM TERMINATES " &
                      "WITHOUT WAITING FOR TASKS THAT DEPEND " &
                      "ON A LIBRARY PACKAGE AND THAT SUCH TASKS " &
                      "CONTINUE TO EXECUTE");

     COMMENT ("THE INVOKING SYSTEM'S JOB CONTROL LOG MUST BE " &
              "EXAMINED TO SEE IF THIS TEST REALLY TERMINATES");

     T := NEW C94004B_PKG.TT;
     T.E;      -- ALLOW TASK TO PROCEED.
     IF T'TERMINATED THEN
          FAILED ("LIBRARY DECLARED TASK PREMATURELY TERMINATED");
     END IF;

     -- RESULT PROCEDURE IS CALLED BY LIBRARY TASK.

END C94004B;
