-- CDB0A02.A
--
--                             Grant of Unlimited Rights
--
--     Under contracts F33600-87-D-0337, F33600-84-D-0280, MDA903-79-C-0687,
--     F08630-91-C-0015, and DCA100-97-D-0025, the U.S. Government obtained
--     unlimited rights in the software and documentation contained herein.
--     Unlimited rights are defined in DFAR 252.227-7013(a)(19).  By making
--     this public release, the Government intends to confer upon all
--     recipients unlimited rights  equal to those held by the Government.
--     These rights include rights to use, duplicate, release or disclose the
--     released technical data and computer software in whole or in part, in
--     any manner and for any purpose whatsoever, and to have or permit others
--     to do so.
--
--                                    DISCLAIMER
--
--     ALL MATERIALS OR INFORMATION HEREIN RELEASED, MADE AVAILABLE OR
--     DISCLOSED ARE AS IS.  THE GOVERNMENT MAKES NO EXPRESS OR IMPLIED
--     WARRANTY AS TO ANY MATTER WHATSOEVER, INCLUDING THE CONDITIONS OF THE
--     SOFTWARE, DOCUMENTATION OR OTHER INFORMATION RELEASED, MADE AVAILABLE
--     OR DISCLOSED, OR THE OWNERSHIP, MERCHANTABILITY, OR FITNESS FOR A
--     PARTICULAR PURPOSE OF SAID MATERIAL.
--*
--
-- OBJECTIVE:
--      Check that several access types can share the same pool.
--
--      Check that any exception propagated by Allocate is
--      propagated by the allocator.
--
--      Check that for an access type S, S'Max_Size_In_Storage_Elements
--      denotes the maximum values for Size_In_Storage_Elements that will
--      be requested via Allocate.
--
-- TEST DESCRIPTION:
--      After checking correct operation of the tree packages, the limits of
--      the storage pools (first the shared user defined storage pool, then
--      the system storage pool) are intentionally exceeded.  The test checks
--      that the correct exception is raised.
--
--
-- TEST FILES:
--      The following files comprise this test:
--
--         FDB0A00.A   (foundation code)
--         CDB0A02.A
--
--
-- CHANGE HISTORY:
--      10 AUG 95   SAIC   Initial version
--      07 MAY 96   SAIC   Disambiguated for 2.1
--      13 FEB 97   PWB.CTA  Reduced minimum allowable
--                           Max_Size_In_Storage_Units, for implementations
--                           with larger storage units
--      25 JAN 01   RLB    Removed dubious checks on Max_Size_In_Storage_Units;
--                         tightened important one.

--!

---------------------------------------------------------- FDB0A00.Pool2

package FDB0A00.Pool2 is
  Pond : Stack_Heap( 5_000 );
end FDB0A00.Pool2;
