-- CXD8002.A
--
--                             Grant of Unlimited Rights
--
--     Under contracts F33600-87-D-0337, F33600-84-D-0280, MDA903-79-C-0687,
--     F08630-91-C-0015, and DCA100-97-D-0025, the U.S. Government obtained
--     unlimited rights in the software and documentation contained herein.
--     Unlimited rights are defined in DFAR 252.227-7013(a)(19).  By making
--     this public release, the Government intends to confer upon all
--     recipients unlimited rights  equal to those held by the Government.
--     These rights include rights to use, duplicate, release or disclose the
--     released technical data and computer software in whole or in part, in
--     any manner and for any purpose whatsoever, and to have or permit others
--     to do so.
--
--                                    DISCLAIMER
--
--     ALL MATERIALS OR INFORMATION HEREIN RELEASED, MADE AVAILABLE OR
--     DISCLOSED ARE AS IS.  THE GOVERNMENT MAKES NO EXPRESS OR IMPLIED
--     WARRANTY AS TO ANY MATTER WHATSOEVER, INCLUDING THE CONDITIONS OF THE
--     SOFTWARE, DOCUMENTATION OR OTHER INFORMATION RELEASED, MADE AVAILABLE
--     OR DISCLOSED, OR THE OWNERSHIP, MERCHANTABILITY, OR FITNESS FOR A
--     PARTICULAR PURPOSE OF SAID MATERIAL.
--*
--
-- OBJECTIVE:
--      Check that Ada.Real_Time.Time can be used in a
--      delay_until_statement.
--      Check that a delay_statement blocks the task for at least
--      as long as the requested delay as measured by Real_Time.Clock.
--
-- TEST DESCRIPTION:
--      This test sets up a number of different tasks, each of a
--      different priority, all doing delays.  The delays are
--      checked to make sure they are long enough.
--
-- APPLICABILITY CRITERIA:
--      This test is only applicable to implementations supporting the
--      Real-Time Annex.
--
--
-- CHANGE HISTORY:
--     26 SEP 95   SAIC    Initial version
--     01 JUN 98   EDS     Provide new initial value for Delay_Amount.
--     29 JUN 98   EDS     Inserted code to guard the Background_Passive task's
--                         accept statement.
--     18 DEC 06   RLB     Corrected test so rounding errors don't cause
--                         failure.
--!

-------------------------------------------------------------------------------
--- The following package does not contain any code to test the features being
--- tested but instead provides some "background noise" for the test.
--- Experience has shown that such background noise can have an effect on the
--- accuracy of the clock.
-------------------------------------------------------------------------------
   package Cxd8002_1 is
   procedure Stop;
end Cxd8002_1;
