
WITH REPORT; USE REPORT;
WITH CA2011B0, CA2011B1;
PROCEDURE CA2011B IS

     PACKAGE P1 IS
          SUBTYPE T IS INTEGER RANGE -100 .. 100;
     END P1;
     USE P1;

     FUNCTION F1 RETURN P1.T;
     FUNCTION F2 RETURN T;

     PACKAGE P2 RENAMES P1;

     FUNCTION F1 RETURN T IS SEPARATE;
     FUNCTION F2 RETURN P2.T IS SEPARATE;

BEGIN
     TEST ("CA2011B", "CHECK THAT FOR A SUBPROGRAM DECLARATION-STUB-" &
                      "BODY TRIPLE, THE DECLARATION-STUB AND STUB-" &
                      "BODY SPECIFICATIONS CAN CONFORM, BUT THE " &
                      "DECLARATON-BODY SPECIFICATIONS NEED NOT");

     IF F1 /= IDENT_INT(100) THEN
          FAILED ("INCORRECT RETURN VALUE FROM FUNCTION 1");
     END IF;

     IF F2 /= IDENT_INT(-100) THEN
          FAILED ("INCORRECT RETURN VALUE FROM FUNCTION 2");
     END IF;

     CA2011B1.P1(3);
     IF CA2011B0.I /= IDENT_INT(3) THEN
          FAILED ("INCORRECT RETURN VALUE FROM PROCEDURE 1");
     END IF;

     CA2011B1.P2(4);
     IF CA2011B0.I /= IDENT_INT(4) THEN
          FAILED ("INCORRECT RETURN VALUE FROM PROCEDURE 2");
     END IF;

     RESULT;
END CA2011B;
